=== debian/changelog ===
rustc-web (1.85.0+dfsg3-1~deb12u3) bookworm; urgency=medium

  * Non-maintainer upload.
  * Remove hardcoded x86_64 string in debian/not-installed to fix non-amd64
    builds.

 -- Andres Salomon <dilinger@debian.org>  Sat, 02 Aug 2025 19:16:01 +0000

rustc-web (1.85.0+dfsg3-1~deb12u2) bookworm; urgency=medium

  * Non-maintainer upload.
  * Fix rustfmt-web to properly depend on libstd-rust-web-*.

 -- Andres Salomon <dilinger@debian.org>  Sat, 02 Aug 2025 14:50:24 +0000

rustc-web (1.85.0+dfsg3-1~deb12u1) bookworm; urgency=medium

  * Non-maintainer upload.
  * Backport to bookworm, as required by newer firefox & chromium.
  * Rename rustc & friends to rustc-web or similar.
  * Generate & include bootstrap compilers via orig-stage0.tar.xz.
  * Disable wasm, -all, and -llvm packages.
  * Vendor libgit2 dependency, switching from llhttp/builtin to the
    (debian package) http-parser.
  * Increase allowed test failures up to 15 to work around random fails.
  * Add 'Provides: cargo' for cargo-web (closes: #1084926).

 -- Andres Salomon <dilinger@debian.org>  Sun, 27 Jul 2025 21:04:10 +0000

rustc (1.85.0+dfsg3-1) unstable; urgency=medium

  * backport fix for gix-features CVE-2025-31130
  * rust-lldb: fix lldb version (Closes: #1100950)
  * cherry-pick fix for crossbeam-channel RUSTSEC-2025-0024

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Thu, 24 Apr 2025 17:47:57 +0200

rustc (1.85.0+dfsg2-3) unstable; urgency=medium

  * baseline: enable SSE2 for i386 build (Closes: #1095862)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 11 Apr 2025 13:40:09 +0200

rustc (1.85.0+dfsg2-2) unstable; urgency=medium

  * Upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 04 Apr 2025 18:24:50 +0200

rustc (1.85.0+dfsg2-1) experimental; urgency=medium

  * d/control: bump libgit2-dev version
  * vendor git2, git2-curl and libgit2-sys bindings for libgit2 1.9
  * cargo: bump git2* dependencies

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Mon, 17 Mar 2025 06:54:23 +0100

rustc (1.85.0+dfsg1-1) unstable; urgency=medium

  * New (stable) upstream release.

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Thu, 20 Feb 2025 19:23:02 +0100

rustc (1.85.0~beta.9+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release 1.85.0~beta999
  * build docs with -j1 to make them reproducible
  * build: make windows libstd build opt-in

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Mon, 17 Feb 2025 13:24:42 +0100

rustc (1.84.0+dfsg1-2) unstable; urgency=medium

  * revert upstream commit breaking cross builds
  * rust-llvm: ship symlink to llvm-objcopy instead of copy of binary

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 21 Jan 2025 11:38:15 +0100

rustc (1.84.0+dfsg1-1) unstable; urgency=medium

  * rust-analyzer: fix build on mips64el
  * fix hurd build (Closes: #1093125)
  * d/control: add Conflicts with rustup (Closes: #1093031)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Thu, 16 Jan 2025 20:46:05 +0100

rustc (1.84.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Stop building wasm32-wasi target
  * Build rust-analyzer (Closes: #1052319)
  * rust-llvm: ship rust-objcopy helper
  * rust-all: add rust-llvm and rust-analyzer packages

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Sat, 11 Jan 2025 16:04:50 +0100

rustc (1.83.0+dfsg1-1) unstable; urgency=medium

  * upload to unstable
  * fix/ignore some test failures

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 04 Dec 2024 18:07:54 +0100

rustc (1.83.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release
  * config: disable downloading LLVM from CI
  * blake3: adapt build.rs to skip bundled C code
  * remove libstd shared library

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Sun, 01 Dec 2024 16:53:12 +0100

rustc (1.82.0+dfsg1-2) unstable; urgency=medium

  * build: re-enable clang-rt on armel/armhf
  * build: drop workaround for riscv64/loong64

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 29 Oct 2024 13:18:35 +0100

rustc (1.82.0+dfsg1-1) unstable; urgency=medium

  * rust-src: ship original Cargo.lock file to fix rust-analyzer for libstd,
    and allow `-Z build-std`
  * build: disable profiler support on armel/armhf
  * build: extend riscv64 workaround to loong64
  * cargo wrapper: fix LTO position in argument lists (Closes: #1086025)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 25 Oct 2024 16:21:38 +0200

rustc (1.82.0+dfsg1-1~exp3) experimental; urgency=medium

  * conditonalize riscv64 workaround
  * fix or disable more broken tests

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 23 Oct 2024 20:39:25 +0200

rustc (1.82.0+dfsg1-1~exp2) experimental; urgency=medium

  * fix some test breakage
  * riscv64: unbreak compiler_builtin build

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 23 Oct 2024 18:03:55 +0200

rustc (1.82.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release
  * New wasi-libc version 0.0~git20240708.3f43ea9
  * switch to LLVM 19
  * set LLVM profiler RT path via config
  * update bootstrap git commit info patch
  * re-instate bootstrap test config patch
  * make rust-src cleanup more robust

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 22 Oct 2024 11:17:40 +0200

rustc (1.81.0+dfsg1-2) unstable; urgency=medium

  * use system libz-sys even when cross-building (Closes: #1084754)
  * drop no longer needed loongarch64 patch
  * add temporary Breaks to force migration of libgit2

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 08 Oct 2024 14:34:41 +0200

rustc (1.81.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Sat, 05 Oct 2024 15:54:29 +0200

rustc (1.81.0+dfsg1-1~exp2) experimental; urgency=medium


