=== debian/control ===
--- 
+++ 
@@ -22,8 +22,8 @@
  libclang-rt-19-dev,
  cmake (>= 3.0),
 # needed by some vendor crates
-# pkgconf:native,
- pkg-config,
+ pkgconf:native,
+ pkgconf,
 # this is sometimes needed by rustc_llvm
  zlib1g-dev:native,
  zlib1g-dev,
